
/*
 * $Id: CntSzStat.cc,v 1.3.6.1 1999/12/19 06:22:22 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "polygraph.h"

#include "ILog.h"
#include "OLog.h"
#include "CntSzStat.h"
#include "gadgets.h"


CntSzStat::CntSzStat(): theSz(0) {
	reset();
}

void CntSzStat::reset() {
	theCnt = 0;
	theSz = BigSize(0);
}

OLog &CntSzStat::store(OLog &log) const {
	return log << theCnt << theSz;
}

ILog &CntSzStat::load(ILog &log) {
	return log >> theCnt >> theSz;
}

CntSzStat &CntSzStat::operator +=(const CntSzStat &hr) {
	theCnt += hr.theCnt;
	theSz += hr.theSz;
	return *this;
}

ostream &CntSzStat::print(ostream &os, const String &pfx) const {
	os << pfx << "count:    \t " << theCnt << endl;
	os << pfx << "size.sum: \t " << theSz.byted() << endl;
	os << pfx << "size.mean:\t " << Ratio(theSz.byted(), theCnt) << endl;
	return os;
}
