
/*
 * $Id: LogIter.cc,v 1.1.2.1 1999/12/19 06:31:28 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "pgl.h"
#include "LogIter.h"

#include "AgentSym.h"
#include "PglNetAddrSym.h"


LogIter::LogIter(ILog *aLog): theLog(0) {
	if (aLog)
		start(aLog);
}

LogIter &LogIter::start(ILog *aLog) {
	theLog = aLog;
	thePx = LogEntryPx();
	sync();
	return *this;
}

bool LogIter::eof() const {
	return !theLog || !*theLog || !thePx;
}

LogIter::operator void *() const {
	return !eof() ? (void*)(-1) : 0;
}

LogIter &LogIter::operator ++() {
	Assert(theLog);
	theLog->endEntry();
	sync();
	return *this;
}

const LogEntryPx &LogIter::operator *() {
	Assert(!eof());
	return thePx;
}

void LogIter::sync() {
	thePx = theLog->begEntry();
	if (eof())
		thePx = LogEntryPx();
}
