
/*
 * $Id: XactStatRec.cc,v 1.1.2.2 1999/10/23 23:11:38 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "polygraph.h"

#include "OLog.h"
#include "ILog.h"
#include "XactStatRec.h"

XactStatRec::XactStatRec(): theOwnerSeqId(-1), theConnSeqId(-1), 
	theQueueMsec(0), theLifeMsec(0), theEmbedCount(-1) {
}

void XactStatRec::store(OLog &ol) const {
	ol << theId << theOwnerSeqId << theConnSeqId
		<< theStartTime << theQueueMsec << theLifeMsec
		<< theEmbedCount << theRepSize << theOidRec;
}

void XactStatRec::load(ILog &il) {
	il >> theId >> theOwnerSeqId >> theConnSeqId
		>> theStartTime >> theQueueMsec >> theLifeMsec
		>> theEmbedCount >> theRepSize >> theOidRec;
}
