
/*
 * $Id: ConnCloseStat.h,v 1.2.6.2 2000/01/13 06:05:50 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_CONNECTION_CLOSE_STATISTICS_H
#define PG_CONNECTION_CLOSE_STATISTICS_H

#include "Array.h"
#include "LogObj.h"
#include "histograms.h"

class ConnCloseStatItem;

// groups stats for all close kinds
class ConnCloseStat: public LogObj {
	public:
		typedef enum { ckActive = 0, ckIdleLocal, ckIdleForeign, ckEnd } CloseKind;

	public:
		ConnCloseStat();
		virtual ~ConnCloseStat();

		void useHist(Log2Hist &acc) const; // totals
		void ttlHist(TimeHist &acc) const;
		const Log2Hist &useHist(int kind) const; // specifics
		const TimeHist &ttlHist(int kind) const;

		void record(CloseKind kind, Time ttl, int useCnt);
		void add(const ConnCloseStat &s);
		
		virtual OLog &store(OLog &ol) const;
		virtual ILog &load(ILog &il);

		ostream &print(ostream &os, const String &pfx) const;

	protected:
		Array<ConnCloseStatItem*> theStats;
};

#endif
