
/*
 * $Id: PglKnownNamesSym.cc,v 1.1.2.1 1999/11/23 00:17:59 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "pgl.h"

#include "PglKnownNamesSym.h"


KnownNamesSym::KnownNamesSym(const String &anItemType): ArraySym(anItemType) {
}

bool KnownNamesSym::isA(const String &type) const {
	return ArraySym::isA(type) || type == "KnownNames";
}

ArraySym *KnownNamesSym::cloneType(const String &itemType) const {
	return new KnownNamesSym(itemType);
}
