
/*
 * $Id: PopModel.cc,v 1.2.4.2 2000/01/13 00:13:51 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "pgl.h"

#include "Assert.h"
#include "PopModel.h"

PopModel::~PopModel() {
}

int PopModel::choose(RndGen &rng, int lastOid, int wsCap) {
	Assert(wsCap != 0);
	const int offset = (0 < wsCap && wsCap < lastOid) ? lastOid-wsCap : 0;
	const int oid = offset + choose(rng, lastOid - offset);

	Should(0 < oid && oid <= lastOid);
	return oid;
}

