
/*
 * $Id: NetPipeArrIter.h,v 1.1.2.1 1999/10/31 03:10:10 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_NETWORK_PIPE_ARRAY_ITERATOR_H
#define PG_NETWORK_PIPE_ARRAY_ITERATOR_H

#include "HostsBasedIter.h"

class NetPipeSym;

// agent array iterator, based on HostsBasedIter
class NetPipeArrIter: public HostsBasedIter {
	public:
		typedef Array<NetPipeSym*> CfgSyms;

	public:
		NetPipeArrIter(CfgSyms &aCfgSyms, const Addrs *aLocalAddrs = 0);

		NetPipeSym *pipeSym();

	protected:
		HostsBasedSym *cfgSym(int idx) const;
		virtual int cfgCount() const;

	protected:
		CfgSyms theCfgs;
};

#endif
