
/*
 * $Id: PglExprSym.h,v 1.6 1999/09/07 17:48:03 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PGL_EXPRESSION_SYMBOL_H
#define PGL_EXPRESSION_SYMBOL_H

#include "SynSym.h"

// base class for all kind of "expressions"
class ExpressionSym: public SynSym {
	public:
		ExpressionSym(const char *aType): SynSym(aType) {}

		// clone self and apply a given operator (unary or binary);
		// by default, complains about unsupported operation
		virtual ExpressionSym *unOper(const String &op) const;
		virtual ExpressionSym *bnOper(const String &op, const SynSym &exp) const;

		virtual bool isA(const String &type) const;

	protected:
		void checkDenom(int val) const;
		void checkDenom(double val) const;
};

#endif
