
/*
 * $Id: NetDouble.h,v 1.3.6.1 1999/10/20 18:53:50 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef X_NET_DOUBLE_H
#define X_NET_DOUBLE_H

#include <sys/types.h>

/* BSD hton */
#include <sys/param.h>

/* IRIX hton */
#include <netinet/in.h>

/* Solaris hton */
#include <arpa/inet.h>


// binary, fpoint-representation-independent storage for doubles
class NetDouble {
	public:
		NetDouble(): mnt(0), exp(0) {}
		NetDouble(double x);     // extracts components 

		operator double() const; // merges components

		inline bool operator ==(const NetDouble &d);
		inline bool operator !=(const NetDouble &d);

	public:
		int mnt; // mantissa
		int exp; // exponent
};

inline
bool NetDouble::operator ==(const NetDouble &d) {
	return mnt == d.mnt && exp == d.exp;
}

inline
bool NetDouble::operator !=(const NetDouble &d) {
	return mnt != d.mnt || exp != d.exp;
}

#endif
